# struct Log::Context

- Log::Context
- Struct
- Value
- Object

##
Defined in:

log/main.cr

##
Constructors

- .new(metadata : Metadata)

##
Instance Method Summary

- #clear : Nil

  Clears the current `Fiber` logging context.

- #metadata : Metadata
- #set(values) : Nil

  Extends the current `Fiber` logging context.

- #set(**kwargs)

  Extends the current `Fiber` logging context.

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(metadata : Metadata) #

##
Instance Method Detail

def clear : Nil #

Clears the current `Fiber` logging context.

    Log.context.clear
    Log.info { "message with empty context" }

def metadata : Metadata #
def set(values) : Nil #

Extends the current `Fiber` logging context.

    Log.context.set a: 1
    Log.context.set b: 2
    Log.info { %q(message with a: 1, b: 2 context") }
    h = {:c => "3"}
    Log.context.set extra: h
    Log.info { %q(message with a: 1, b: 2, extra: {"c" => "3"} context) }
    h = {"c" => 3}
    Log.context.set extra: h
    Log.info { %q(message with a: 1, b: 2, extra: {"c" => 3} context) }

def set(**kwargs) #

Extends the current `Fiber` logging context.

    Log.context.set a: 1
    Log.context.set b: 2
    Log.info { %q(message with a: 1, b: 2 context") }
    h = {:c => "3"}
    Log.context.set extra: h
    Log.info { %q(message with a: 1, b: 2, extra: {"c" => "3"} context) }
    h = {"c" => 3}
    Log.context.set extra: h
    Log.info { %q(message with a: 1, b: 2, extra: {"c" => 3} context) }